variables:
  IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
#  GIT_SSL_NO_VERIFY: "true"
  
stages:
  - build
  - test
  - deploy

build:
  image: docker:latest
  services: 
    - docker:dind
  stage: build
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
    - docker logout $CI_REGISTRY

test:
  image: docker:latest
  services: 
    - docker:dind
  stage: test
  script:
#    - apk update && apk add python3
#    - pip3 install --no-cache-dir -r requirements.txt
#    - sleep 50s
    - cat test.py


deploy:
  image: 
    name: bitnami/kubectl:latest
#    entrypoint: ["/bin/sh", "-c"]
    entrypoint: [""]
  stage: deploy
  script:
    - mkdir -p ./.kube
    - echo -n $KUBE_CONFIG | base64 -d > ./.kube/config
    - export KUBECONFIG="./.kube/config:./.kube/system"
#    - echo $CERTIFICATE_AUTHORITY_DATA > ./deploy.crt
    - kubectl config set-cluster kuber-cluster-1 --server="$KUBE_URL" #--certificate-authority=./deploy.crt --embed-certs=true
    - kubectl config set-credentials kuber-cluster-1 --token="$KUBE_TOKEN"
    - kubectl config set-context kuber-cluster-1 --cluster kuber-cluster-1 --user kuber-cluster-1
    - kubectl config use-context kuber-cluster-1

#    - kubectl create secret docker-registry my-reg --docker-server=registry.gitlab.com --docker-username=gitlab-ci-token --docker-password=$CI_BUILD_TOKEN --docker-email=slastikhin.nikita@gmail.com --namespace=testapp

#    - kubectl patch serviceaccount ci -p "{imagePullSecrets\: {name\: gitlab-registry}}"
    - sed 's/_APP_NAME_/'"$CI_PROJECT_NAME"'/g; s/_VERSION_/'$CI_COMMIT_SHORT_SHA'/g' deployment.tpl.yaml > deployment.yaml
    - set +e
    - cat deployment.yaml | kubectl delete -f -
    - set -e
##    - kubectl get all   "$CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}"
    - kubectl create secret -n "testapp" docker-registry gitlab-registry --docker-server="$CI_REGISTRY" --docker-username="$CI_REGISTRY_USER" --docker-password="$CI_REGISTRY_PASSWORD" --docker-email="$GITLAB_USER_EMAIL" -o yaml --dry-run | sed 's/dockercfg/dockerconfigjson/g' | kubectl replace -n "testapp" --force -f -    


    - kubectl apply -f deployment.yaml

#    - kubectl set image deployment/my.t-back backend=slastikhin.nikita/my.t-back:latest --kubeconfig ./.kube/config --namespace testapp
